Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Insertion/StochasticInsertionMoveGenerator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Insertion/StochasticInsertionMoveGenerator.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Insertion/StochasticInsertionMoveGenerator.cs	(revision 14128)
@@ -25,4 +25,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
@@ -58,8 +59,8 @@
     }
 
-    public static InsertionMove[] Apply(PackingSequenceEncoding PackingSequence, IRandom random, int sampleSize) {
+    public static InsertionMove[] Apply(Permutation packingSequence, IRandom random, int sampleSize) {
 
       int nrOfBins = 0;
-      foreach (int binNr in PackingSequence.PackingSequence) {
+      foreach (int binNr in packingSequence) {
         if (binNr > nrOfBins)
           nrOfBins = binNr;
@@ -67,5 +68,5 @@
       nrOfBins++;
       var generatedMoves = new List<InsertionMove>();
-      var moves = new List<InsertionMove>(ExhaustiveInsertionMoveGenerator.Generate(PackingSequence, nrOfBins));
+      var moves = new List<InsertionMove>(ExhaustiveInsertionMoveGenerator.Generate(packingSequence, nrOfBins));
       int moveCount = moves.Count;
       for (int i = 0; i < sampleSize; i++) {
@@ -76,7 +77,7 @@
     }
 
-    protected override InsertionMove[] GenerateMoves(PackingSequenceEncoding SwapSequence) {
+    protected override InsertionMove[] GenerateMoves(Permutation packingSequence) {
       IRandom random = RandomParameter.ActualValue;
-      return Apply(SwapSequence, random, SampleSizeParameter.ActualValue.Value);
+      return Apply(packingSequence, random, SampleSizeParameter.ActualValue.Value);
     }
   }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/SequenceMove.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/SequenceMove.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/SequenceMove.cs	(revision 14128)
@@ -24,13 +24,14 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Problems.BinPacking;
 
 namespace HeuristicLab.Encodings.PackingEncoding.PackingSequence {
-  [Item("SequenceMove", "An abstract move for a packingSequence encoded solution.")]
+  [Item("SequenceMove", "An abstract move for a packing sequence encoded solution.")]
   [StorableClass]
-  public abstract class SequenceMove : Item, IPackingMove {
+  public abstract class SequenceMove : Item, IPackingMove<Permutation> {
     [Storable]
-    public PackingSequenceEncoding PackingSequence { get; protected set; }
+    public Permutation PackingSequence { get; protected set; }
 
     [StorableConstructor]
@@ -41,10 +42,10 @@
           this.PackingSequence = cloner.Clone(original.PackingSequence);
     }
-    public SequenceMove(PackingSequenceEncoding packingSequence)
+    public SequenceMove(Permutation packingSequence)
       : base() {
         PackingSequence = packingSequence;
     }
 
-    public abstract IPackingSolutionEncoding GetSolutionAfterMove();
+    public abstract Permutation GetSolutionAfterMove();
     public abstract Type GetMoveAttributeType();
     public abstract SequenceMoveAttribute GetAttribute(double quality);
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/SequenceTabuMaker.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/SequenceTabuMaker.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/SequenceTabuMaker.cs	(revision 14128)
@@ -23,4 +23,5 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Optimization.Operators;
 using HeuristicLab.Parameters;
@@ -32,9 +33,9 @@
   [StorableClass]
   public class SequenceTabuMaker : TabuMaker, IPackingSequenceMoveOperator {
-    public ILookupParameter<IPackingMove> PackingMoveParameter {
-      get { return (ILookupParameter<IPackingMove>)Parameters["PackingMove"]; }
+    public ILookupParameter<IPackingMove<Permutation>> PackingMoveParameter {
+      get { return (ILookupParameter<IPackingMove<Permutation>>)Parameters["PackingMove"]; }
     }
-    public ILookupParameter<PackingSequenceEncoding> PackingSequenceParameter {
-      get { return (ILookupParameter<PackingSequenceEncoding>)Parameters["PackingSequence"]; }
+    public ILookupParameter<Permutation> PackingSequenceParameter {
+      get { return (ILookupParameter<Permutation>)Parameters["PackingSequence"]; }
     }
 
@@ -44,6 +45,6 @@
     public SequenceTabuMaker()
       : base() {
-      Parameters.Add(new LookupParameter<IPackingMove>("PackingMove", "The move to evaluate."));
-      Parameters.Add(new LookupParameter<PackingSequenceEncoding>("PackingSequence", "The solution to evaluate."));
+      Parameters.Add(new LookupParameter<IPackingMove<Permutation>>("PackingMove", "The move to evaluate."));
+      Parameters.Add(new LookupParameter<Permutation>("PackingSequence", "The solution to evaluate."));
     }
 
@@ -53,6 +54,5 @@
 
     protected override IItem GetTabuAttribute(bool maximization, double quality, double moveQuality) {
-      IPackingMove move = PackingMoveParameter.ActualValue;
-      PackingSequenceEncoding PackingSequence = PackingSequenceParameter.ActualValue;
+      var move = PackingMoveParameter.ActualValue;
       double baseQuality = moveQuality;
       if (maximization && quality > moveQuality || !maximization && quality < moveQuality)
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Swap2/ExhaustiveSwap2MoveGenerator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Swap2/ExhaustiveSwap2MoveGenerator.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Swap2/ExhaustiveSwap2MoveGenerator.cs	(revision 14128)
@@ -24,4 +24,5 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -39,15 +40,15 @@
       return new ExhaustiveSwap2MoveGenerator(this, cloner);
     }
-    public static IEnumerable<Swap2Move> Generate(PackingSequenceEncoding PackingSequence, int nrOfBins) {
-      for (int i = 0; i < PackingSequence.PackingSequence.Length - 1; i++)
-        for (int j = i + 1; j < PackingSequence.PackingSequence.Length; j++) {
+    public static IEnumerable<Swap2Move> Generate(Permutation packingSequence, int nrOfBins) {
+      for (int i = 0; i < packingSequence.Length - 1; i++)
+        for (int j = i + 1; j < packingSequence.Length; j++) {
           if (j != i)
-            yield return new Swap2Move(i, j, PackingSequence);
+            yield return new Swap2Move(i, j, packingSequence);
         }
     }
 
-    public static Swap2Move[] Apply(PackingSequenceEncoding PackingSequence) {
+    public static Swap2Move[] Apply(Permutation packingSequence) {
       int nrOfBins = 0;
-      foreach (int binNr in PackingSequence.PackingSequence) {
+      foreach (int binNr in packingSequence) {
         if (binNr > nrOfBins)
           nrOfBins = binNr;
@@ -55,8 +56,8 @@
       nrOfBins++;
 
-      int totalMoves = (PackingSequence.PackingSequence.Length * (PackingSequence.PackingSequence.Length - 1)) / 2;
+      int totalMoves = (packingSequence.Length * (packingSequence.Length - 1)) / 2;
       Swap2Move[] moves = new Swap2Move[totalMoves];
       int count = 0;
-      foreach (Swap2Move move in Generate(PackingSequence, nrOfBins)) {
+      foreach (Swap2Move move in Generate(packingSequence, nrOfBins)) {
         moves[count++] = move;
       }
@@ -64,6 +65,6 @@
     }
 
-    protected override Swap2Move[] GenerateMoves(PackingSequenceEncoding PackingSequence) {
-      return Apply(PackingSequence);
+    protected override Swap2Move[] GenerateMoves(Permutation packingSequence) {
+      return Apply(packingSequence);
     }
   }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Swap2/StochasticSwap2MoveGenerator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Swap2/StochasticSwap2MoveGenerator.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Swap2/StochasticSwap2MoveGenerator.cs	(revision 14128)
@@ -25,4 +25,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
@@ -58,8 +59,8 @@
     }
 
-    public static Swap2Move[] Apply(PackingSequenceEncoding PackingSequence, IRandom random, int sampleSize) {
+    public static Swap2Move[] Apply(Permutation packingSequence, IRandom random, int sampleSize) {
 
       int nrOfBins = 0;
-      foreach (int binNr in PackingSequence.PackingSequence) {
+      foreach (int binNr in packingSequence) {
         if (binNr > nrOfBins)
           nrOfBins = binNr;
@@ -67,5 +68,5 @@
       nrOfBins++;
       var generatedMoves = new List<Swap2Move>();
-      var moves = new List<Swap2Move>(ExhaustiveSwap2MoveGenerator.Generate(PackingSequence, nrOfBins));
+      var moves = new List<Swap2Move>(ExhaustiveSwap2MoveGenerator.Generate(packingSequence, nrOfBins));
       int moveCount = moves.Count;
       for (int i = 0; i < sampleSize; i++) {
@@ -76,7 +77,7 @@
     }
 
-    protected override Swap2Move[] GenerateMoves(PackingSequenceEncoding SwapSequence) {
+    protected override Swap2Move[] GenerateMoves(Permutation packingSequence) {
       IRandom random = RandomParameter.ActualValue;
-      return Apply(SwapSequence, random, SampleSizeParameter.ActualValue.Value);
+      return Apply(packingSequence, random, SampleSizeParameter.ActualValue.Value);
     }
   }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Swap2/Swap2Move.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Swap2/Swap2Move.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Swap2/Swap2Move.cs	(revision 14128)
@@ -32,5 +32,5 @@
   [Item("Swap2 Move", "A move on a Sequence vector that is specified by two group-assignment-indexes.")]
   [StorableClass]
-  public class Swap2Move : SequenceMove, IPackingMove {
+  public class Swap2Move : SequenceMove, IPackingMove<Permutation> {
     [Storable]
     public int Index1 { get; protected set; }
@@ -45,6 +45,6 @@
       this.Index2 = original.Index2;
     }
-    public Swap2Move(int index1, int index2, PackingSequenceEncoding PackingSequence)
-      : base(PackingSequence) {
+    public Swap2Move(int index1, int index2, Permutation packingSequence)
+      : base(packingSequence) {
       Index1 = index1;
       Index2 = index2;
@@ -55,9 +55,8 @@
     }
 
-    public override IPackingSolutionEncoding GetSolutionAfterMove() {
-      PackingSequenceEncoding newSolution = new PackingSequenceEncoding();
-      newSolution.PackingSequence = (Permutation)PackingSequence.PackingSequence.Clone(new Cloner());
-      newSolution.PackingSequence[Index1] = PackingSequence.PackingSequence[Index2];
-      newSolution.PackingSequence[Index2] = PackingSequence.PackingSequence[Index1];
+    public override Permutation GetSolutionAfterMove() {
+      Permutation newSolution = (Permutation)PackingSequence.Clone(new Cloner());
+      newSolution[Index1] = PackingSequence[Index2];
+      newSolution[Index2] = PackingSequence[Index1];
       return newSolution;
     }
@@ -68,5 +67,5 @@
 
     public override SequenceMoveAttribute GetAttribute(double quality) {
-      return new Swap2MoveAttribute(Index1, Index2, PackingSequence.PackingSequence[Index1], PackingSequence.PackingSequence[Index2], quality);
+      return new Swap2MoveAttribute(Index1, Index2, PackingSequence[Index1], PackingSequence[Index2], quality);
     }
 
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Swap2/Swap2MoveGenerator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Swap2/Swap2MoveGenerator.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/Moves/Swap2/Swap2MoveGenerator.cs	(revision 14128)
@@ -23,4 +23,5 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Operators;
 using HeuristicLab.Optimization;
@@ -36,9 +37,9 @@
       get { return false; }
     }
-    public ILookupParameter<PackingSequenceEncoding> PackingSequenceParameter {
-      get { return (ILookupParameter<PackingSequenceEncoding>)Parameters["PackingSequence"]; }
+    public ILookupParameter<Permutation> PackingSequenceParameter {
+      get { return (ILookupParameter<Permutation>)Parameters["PackingSequence"]; }
     }
-    public ILookupParameter<IPackingMove> PackingMoveParameter {
-      get { return (LookupParameter<IPackingMove>)Parameters["PackingMove"]; }
+    public ILookupParameter<IPackingMove<Permutation>> PackingMoveParameter {
+      get { return (LookupParameter<IPackingMove<Permutation>>)Parameters["PackingMove"]; }
     }
     protected ScopeParameter CurrentScopeParameter {
@@ -51,11 +52,11 @@
     public Swap2MoveGenerator()
       : base() {
-      Parameters.Add(new LookupParameter<PackingSequenceEncoding>("PackingSequence", "The Sequence vector for which moves should be generated."));
-      Parameters.Add(new LookupParameter<IPackingMove>("PackingMove", "The moves that should be generated in subscopes."));
+      Parameters.Add(new LookupParameter<Permutation>("PackingSequence", "The Sequence vector for which moves should be generated."));
+      Parameters.Add(new LookupParameter<IPackingMove<Permutation>>("PackingMove", "The moves that should be generated in subscopes."));
       Parameters.Add(new ScopeParameter("CurrentScope", "The current scope where the moves should be added as subscopes."));
     }
 
     public override IOperation Apply() {
-      PackingSequenceEncoding ps = PackingSequenceParameter.ActualValue;
+      Permutation ps = PackingSequenceParameter.ActualValue;
       Swap2Move[] moves = GenerateMoves(ps);
       Scope[] moveScopes = new Scope[moves.Length];
@@ -68,5 +69,5 @@
     }
 
-    protected abstract Swap2Move[] GenerateMoves(PackingSequenceEncoding PackingSequence);
+    protected abstract Swap2Move[] GenerateMoves(Permutation packingSequence);
   }
 }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequenceCrossover.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequenceCrossover.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequenceCrossover.cs	(revision 14128)
@@ -23,4 +23,5 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Problems.BinPacking;
@@ -29,5 +30,5 @@
   [Item("PackingSequenceCrossover", "An operator which crosses two PackingSequence representations.")]
   [StorableClass]
-  public abstract class PackingSequenceCrossover : PackingSolutionCrossover, IPackingSequenceOperator {
+  public abstract class PackingSequenceCrossover : PackingSolutionCrossover<Permutation>, IPackingSequenceOperator {
 
     [StorableConstructor]
@@ -36,9 +37,9 @@
     public PackingSequenceCrossover()
       : base() {
-        ParentsParameter.ActualName = "PackingSequence";
-        ChildParameter.ActualName = "PackingSequence";
+      ParentsParameter.ActualName = "PackingSequence";
+      ChildParameter.ActualName = "PackingSequence";
     }
 
-    public abstract PackingSequenceEncoding Cross(IRandom random, PackingSequenceEncoding parent1, PackingSequenceEncoding parent2);
+    public abstract Permutation Cross(IRandom random, Permutation parent1, Permutation parent2);
 
     public override IOperation Apply() {
@@ -46,5 +47,5 @@
 
       ChildParameter.ActualValue =
-        Cross(RandomParameter.ActualValue, parents[0] as PackingSequenceEncoding, parents[1] as PackingSequenceEncoding);
+        Cross(RandomParameter.ActualValue, parents[0], parents[1]);
 
       return base.Apply();
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequenceInversionManipulator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequenceInversionManipulator.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequenceInversionManipulator.cs	(revision 14128)
@@ -43,6 +43,6 @@
     }
 
-    protected override void Manipulate(IRandom random, PackingSequenceEncoding individual) {
-      InversionManipulator.Apply(random, individual.PackingSequence);
+    protected override void Manipulate(IRandom random, Permutation individual) {
+      InversionManipulator.Apply(random, individual);
     }
   }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequenceManipulator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequenceManipulator.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequenceManipulator.cs	(revision 14128)
@@ -24,4 +24,5 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Problems.BinPacking;
@@ -30,5 +31,5 @@
   [Item("PackingSequenceManipulator", "An operator which manipulates a PackingSequence representation.")]
   [StorableClass]
-  public abstract class PackingSequenceManipulator : PackingSolutionManipulator, IPackingSequenceOperator {
+  public abstract class PackingSequenceManipulator : PackingSolutionManipulator<Permutation>, IPackingSequenceOperator {
     [StorableConstructor]
     protected PackingSequenceManipulator(bool deserializing) : base(deserializing) { }
@@ -39,8 +40,8 @@
     }
 
-    protected abstract void Manipulate(IRandom random, PackingSequenceEncoding individual);
+    protected abstract void Manipulate(IRandom random, Permutation individual);
 
     public override IOperation Apply() {
-      var solution = EncodedSolutionParameter.ActualValue as PackingSequenceEncoding;
+      var solution = EncodedSolutionParameter.ActualValue;
       if (solution == null) throw new InvalidOperationException("PackingSolutionEncoding was not found or is not of type PackingSequenceEncoding.");
       Manipulate(RandomParameter.ActualValue, solution);
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequenceOrderCrossover.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequenceOrderCrossover.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequenceOrderCrossover.cs	(revision 14128)
@@ -30,5 +30,5 @@
   [Item("PackingSequence OX", "An operator which crosses two PackingSequence representations using the OX-strategy.")]
   [StorableClass]
-  public class PackingSequenceOrderCrossover : PackingSequenceCrossover, IPackingSequenceOperator {
+  public class PackingSequenceOrderCrossover : PackingSequenceCrossover {
 
     [StorableConstructor]
@@ -42,8 +42,6 @@
     }
 
-    public override PackingSequenceEncoding Cross(IRandom random, PackingSequenceEncoding parent1, PackingSequenceEncoding parent2) {
-      PackingSequenceEncoding result = new PackingSequenceEncoding();
-      result.PackingSequence = OrderCrossover.Apply(random, parent1.PackingSequence, parent2.PackingSequence);
-      return result;
+    public override Permutation Cross(IRandom random, Permutation parent1, Permutation parent2) {
+      return OrderCrossover.Apply(random, parent1, parent2);
     }
   }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequencePartiallyMatchedCrossover.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequencePartiallyMatchedCrossover.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequencePartiallyMatchedCrossover.cs	(revision 14128)
@@ -31,5 +31,5 @@
   [Item("PackingSequence PMX", "An operator which crosses two PackingSequence representations using the OX-strategy.")]
   [StorableClass]
-  public class PackingSequencePartiallyMatchedCrossover : PackingSequenceCrossover, IPackingSequenceOperator {
+  public class PackingSequencePartiallyMatchedCrossover : PackingSequenceCrossover {
 
     [StorableConstructor]
@@ -43,8 +43,6 @@
     }
 
-    public override PackingSequenceEncoding Cross(IRandom random, PackingSequenceEncoding parent1, PackingSequenceEncoding parent2) {
-      PackingSequenceEncoding result = new PackingSequenceEncoding();
-      result.PackingSequence = PartiallyMatchedCrossover.Apply(random, parent1.PackingSequence, parent2.PackingSequence);
-      return result;
+    public override Permutation Cross(IRandom random, Permutation parent1, Permutation parent2) {
+      return PartiallyMatchedCrossover.Apply(random, parent1, parent2);
     }
   }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequenceRandomCreator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequenceRandomCreator.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequenceRandomCreator.cs	(revision 14128)
@@ -33,15 +33,15 @@
   [Item("PackingSequenceCreator", "Creator class used to create PackingSequence solutions for bin packing problems.")]
   [StorableClass]
-  public class PackingSequenceRandomCreator : PackingSolutionCreator, IStochasticOperator {
+  public class PackingSequenceRandomCreator : PackingSolutionCreator, IPackingSequenceCreator, IStochasticOperator {
 
     public ILookupParameter<IRandom> RandomParameter {
       get { return (LookupParameter<IRandom>)Parameters["Random"]; }
     }
-    public IValueLookupParameter<IntValue> PackingItemsParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["PackingItems"]; }
+    public ILookupParameter<IntValue> NumberOfPackingItemsParameter {
+      get { return (ILookupParameter<IntValue>)Parameters["NumberOfItems"]; }
     }
 
-    public ILookupParameter<PackingSequence> SolutionParameter {
-      get { return (ILookupParameter<PackingSequence>)Parameters["PackingItems"]; }
+    public ILookupParameter<Permutation> SolutionParameter {
+      get { return (ILookupParameter<Permutation>)Parameters["PackingSequence"]; }
     }
 
@@ -58,22 +58,18 @@
       : base() {
       Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("PackingItems", "The number of packing-items handled in this problem instance."));
-      Parameters.Add(new LookupParameter<PackingSequence>("PackingSequence"));
-
-      SolutionParameter.ActualName = "PackingSequence";
+      Parameters.Add(new ValueLookupParameter<IntValue>("NumberOfPackingItems", "The number of packing-items handled in this problem instance."));
+      Parameters.Add(new LookupParameter<Permutation>("PackingSequence", "The randomly created solution candidate."));
     }
 
     public override IOperation Apply() {
-      Apply(PackingItemsParameter.ActualValue.Value, RandomParameter.ActualValue);
+      Apply(NumberOfPackingItemsParameter.ActualValue.Value, RandomParameter.ActualValue);
       return base.Apply();
     }
 
-    public static PackingSequenceEncoding Apply(int items, IRandom random) {
-      var solution = new PackingSequenceEncoding();
-      solution.PackingSequence = new Permutation(PermutationTypes.Absolute, items, random);
-      return solution;
+    public static Permutation Apply(int items, IRandom random) {
+      return new Permutation(PermutationTypes.Absolute, items, random);
     }
     protected override IItem CreateSolution() {
-      return Apply(PackingItemsParameter.ActualValue.Value, RandomParameter.ActualValue);
+      return Apply(NumberOfPackingItemsParameter.ActualValue.Value, RandomParameter.ActualValue);
     }
   }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequenceScrambleManipulator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequenceScrambleManipulator.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSequence/PackingSequenceScrambleManipulator.cs	(revision 14128)
@@ -41,6 +41,6 @@
     }
 
-    protected override void Manipulate(IRandom random, PackingSequenceEncoding individual) {
-      ScrambleManipulator.Apply(random, individual.PackingSequence);
+    protected override void Manipulate(IRandom random, Permutation individual) {
+      ScrambleManipulator.Apply(random, individual);
     }
   }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSolutionCrossover.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSolutionCrossover.cs	(revision 14127)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/PackingSolutionCrossover.cs	(revision 14128)
@@ -32,11 +32,12 @@
   [Item("PackingSolutionCrossover", "A bin packing crossover operation.")]
   [StorableClass]
-  public abstract class PackingSolutionCrossover : SingleSuccessorOperator, IPackingSolutionCrossover, IStochasticOperator {
+  public abstract class PackingSolutionCrossover<T> : SingleSuccessorOperator, IPackingSolutionCrossover<T>, IStochasticOperator
+  where T : class, IItem {
 
-    public ILookupParameter<IPackingSolutionEncoding> ChildParameter {
-      get { return (ILookupParameter<IPackingSolutionEncoding>)Parameters["Child"]; }
+    public ILookupParameter<T> ChildParameter {
+      get { return (ILookupParameter<T>)Parameters["Child"]; }
     }
-    public IScopeTreeLookupParameter<IPackingSolutionEncoding> ParentsParameter {
-      get { return (IScopeTreeLookupParameter<IPackingSolutionEncoding>)Parameters["Parents"]; }
+    public IScopeTreeLookupParameter<T> ParentsParameter {
+      get { return (IScopeTreeLookupParameter<T>)Parameters["Parents"]; }
     }
     public ILookupParameter<IRandom> RandomParameter {
@@ -46,11 +47,11 @@
     [StorableConstructor]
     protected PackingSolutionCrossover(bool deserializing) : base(deserializing) { }
-    protected PackingSolutionCrossover(PackingSolutionCrossover original, Cloner cloner) : base(original, cloner) { }
+    protected PackingSolutionCrossover(PackingSolutionCrossover<T> original, Cloner cloner) : base(original, cloner) { }
     public PackingSolutionCrossover()
       : base() {
       Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
-      Parameters.Add(new LookupParameter<IPackingSolutionEncoding>("Child", "The child solution resulting from the crossover."));
+      Parameters.Add(new LookupParameter<T>("Child", "The child solution resulting from the crossover."));
       ChildParameter.ActualName = "EncodedSolution";
-      Parameters.Add(new ScopeTreeLookupParameter<IPackingSolutionEncoding>("Parents", "The parent solution which should be crossed."));
+      Parameters.Add(new ScopeTreeLookupParameter<T>("Parents", "The parent solution which should be crossed."));
       ParentsParameter.ActualName = "EncodedSolution";
     }
